#include <pic16f84a.h>
/* ejerext1.c
 * Jose Luis Dobler Trueba
 * Entradas: Leer microswitches A1...A4.  Salidas:  Escribir el estado
 * de los microswitches en B1...B4.  Loop continuo.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext1.c */

#define TIEMPO 200

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(void) {
	unsigned int i;
	for(i = 0; i < TIEMPO; i++);
	return PORTA;
}

void main(void) {

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;
	TRISB = 0;

	while(1) {
		PORTB = (check() & 0x1e);
	}
}
