#include <pic16f84a.h>
/* ejerext10.c
 * Jose Luis Dobler Trueba
 * A traves de los microswitches, leer 2 numeros A y B del 0 al 15.
 * Mostrar en los LEDS la multiplicacion de A x B, en binario.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext10.c */

#define PAUSA 65000
#define FLASH 1000
#define PAUSAS 5

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(unsigned int n) {
	unsigned int i;
	for(i = 0; i < n; i++);
	return PORTA;
}

void main(void) {

	char n1, n2, i;
	unsigned int res = 0;

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;
	TRISB = 0x00;

	n1 = (check(0) & 0x1e) >> 1;
	PORTB = n1 << 4;
	for(i = 0; i < PAUSAS; i++) { 
		if(PORTA & 0x01)
			PORTA--;
		check(PAUSA - FLASH);
		if(!(PORTA & 0x01))
			PORTA++;
		check(PAUSA);
		PORTB ++;
	}
	n2 = (check(0) & 0x1e) >> 1;
	PORTB = n2 << 4;
	for(i = 0; i < PAUSAS; i++) { 
		if(PORTA & 0x01)
			PORTA--;
		check(PAUSA - FLASH);
		if(!(PORTA & 0x01))
			PORTA++;
		check(PAUSA);
		PORTB ++;
	}
	res = n1 * n2;
	PORTB = 0;
	while(1) {
		PORTB ^= res;
		check(FLASH);
	}
}
