#include <pic16f84a.h>
/* ejerext2.c
 * Jose Luis Dobler Trueba
 * Contador binario.  Encender los leds B0...B7, mostrando los codigos del
 * 0 al 255 en binario.  Los leds encendidos deberan de apagarse antes de 
 * mostrar el siguiente incremento.  Use retrasos de 200 ms.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext2.c */

#define TIEMPO 10000

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(void) {
	unsigned int i;
	for(i = 0; i < TIEMPO; i++);
	return 0;
}

void main(void) {

	PORTA = 0;
	PORTB = 0;
	TRISB = 0;

	while(1) {
		unsigned char i;

		for(i = 0; i < 0xff; i++) {
			PORTB = i;
			PORTB = check();
			PORTB = 0;
			PORTB = check();
		}
	}
}
