#include <pic16f84a.h>
/* ejerext4.c
 * Jose Luis Dobler Trueba
 * Leer los microswitches, A1...A4.  clave de 4 bits (n = 0...15).  Si n = 2,
 * activar el relevador, si n = 7, desactivarlo.  Repetir la rutina.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext4.c */

#define TIEMPO 2000

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(void) {
	unsigned int i;
	for(i = 0; i < TIEMPO; i++);
	return PORTA;
}

void main(void) {

	char n;

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;

	while(1) {
		n = (check() & 0x1e) >> 1;
		if(n == 2  && !(PORTA & 0x01))
			PORTA++;
		else if(n == 7 && (PORTA & 0x01))
			PORTA--;
	}
}
